c       keep this interface so that the difference between
c       the one in UserHook/ForTA/  and in UserHook/DisPara/FleshHist
c       is in the next line
c      1 for ForTA and 2 for FleshHist
c     ***********************
#include "interface2.f"
c     *********************
c       histdep:  2 5 6 7 10 /
c       depth   1000 2000 3000 4000 5000 6000 7000 8000 9000 10000
c       ansites = 5
c       w2hl: 0 1 0 0 2 3 4 0 0 5  0 0 ...

      do i = 1, nsites
         w2hl(i) = 0
         w2il(i) = 0
      enddo
      do i = 1, nsites
         if(histdep(i) .eq. 0) exit
         hnsites = i
         w2hl( histdep(i)) = i
      enddo

      do i = 1, nsites
         if( indivdep(i) .eq. 0) exit
         ansites = i
         w2il( indivdep(i) ) = i
      enddo

c        now hnsites is the  actual number of sites where statistics
c        by histogram is needed.
c        mapping; depth index to array index; where2loc
c     

 
      call kwhistso( binw )  ! specify binary or ascii write of histogaram
                             !  1--> ascii  2--> binary


      rminm = rmin/10.**(bin/2.0d0)
      r=rmin
      dr = 10.**bin 
      rbin(1) = 0.
      do i = 2, nrbin
         rbin(i) = r
         r = r* dr
      enddo

c      return      
c    ******************
c      entry ihist
c
c

c     histogram: instanciate
c         rspec (lateral):  
      if(tklat) then
         do i = 1, hnsites
            do j = 1, 4         ! g,e,mu,had
               call kwhisti(rspec(j, i),
     *              rmin, bin, nrbin,  b'00011' )
               call kwhistai(rspec(j,i), 
     *         "Lateral Dist. of "//ptcl(j),
     *         "lat", "ptcls", .true., power(j), "r", "m.u")
            enddo
         enddo
      endif


c        elosrspec (energy loss lateral)  10m-10km log bin 0.1. e+mu, e,mu
c          
c       
      if(tkelosslat) then
         do i = 1, hnsites
            do j = 1, 3         !   e, mu, e+mu
               call kwhisti( lossrspec(j, i),
     *          rmin, bin, nrbin, b'00011')
               call kwhistai(lossrspec(j, i), 
     *         "dE/dx lateral dist. of "//ptcl2(j),
     *         "dEdxLat", "GeV/(g/cm^2)", .true., power2(j),
     *         "r", "m.u")
            enddo
         enddo   
      endif


      if(tkarspec) then
         do i = 1, hnsites
            do j=1, 4
               call kwhisti2(arspec(j, i),
     *              0.,  30.0, 12,     b'00010',
     *              rmin, bin, nrbin,  b'00011' )
               call kwhistai2(arspec(j,i), 
     *         "Lateral dits. of "//ptcl(j)//" with given Fai bin",
     *         "ar", "ptcls", .true.,  power(j), 
     *         "azimuth", "deg", "r", "m.u")
            enddo
         enddo
      endif
         

c
      if(tkrespec) then
         do i = 1, hnsites
            do j= 1, 2
               call kwhisti2( respec(j, i),
     *             0.01, 0.2, 20,    b'00011', 
     *             500.e-6, 0.1,    50,    b'00001')
               call kwhiststep2(respec(j, i), 2)
               call kwhistai2( respec(j, i),
     *         "Energy Spec. of "//ptcl(j)//" at  diff. r",
     *         "re", "ptcls", .true.,  1., 
     *         "r", "m.u", "E", "GeV")
            enddo
c                 mu            
            call kwhisti2( respec(3, i),
     *            0.01, 0.2, 20       , b'00011', 
     *            0.031627,  0.1,  38, b'00011' )
            call kwhiststep2(respec(3, i), 2)
            call kwhistai2( respec(3, i),
     *      "Energy Spec. of mu at diff. r",
     *      "re", "ptcls", .true.,  0.,
     *      "r",  "m.u", "E", "GeV")
         enddo
      endif


      if(tkrzspec) then
         do i = 1, hnsites
            do j= 1, 2
               call kwhisti2( rzspec(j, i),
     *           0.01,   0.2,  20,  b'00011', 
     *           0.,     1.0,     20,  b'10000')
               call kwhiststep2(rzspec(j, i), 2)
               call kwhistai2( rzspec(j, i),
     *         "Zenith angle dist. of "//ptcl(j)//" at diff. r",
     *         "rz", "ptcls", .true., 0.,
     *         "r", "m.u", "cosz", " ")
            enddo
            call kwhisti2(rzspec(3, i),
     *           0.01, 0.2, 20, b'00011', 
     *           0.,  1.0,   20, b'10000' )  
           call kwhiststep2(rzspec(3, i), 2)
            call kwhistai2( rzspec(3, i),
     *         "Zenith angle dist. of m  with diff. r",
     *         "rz", "ptcls", .true., 0.,
     *         "r", "m.u", "cosz", " ")
         enddo
      endif         


      if(tkzfspec) then
         do i = 1, hnsites
            do j= 1, 3
               call kwhisti2( zfspec(j, i),
     *              0.0,  1.0, 10,  b'10000', 
     *              -1.0, 1.0, 50,  b'10000')
               call kwhiststep2(zfspec(j, i), 2)
               call kwhistai2( zfspec(j, i),
     *         "f=(wx,wy)*(x,y) spectrum of "//ptcl(j)//
     *         " with diff. cosz", 
     *         "zf", "ptcls", .true., 0.,
     *         "cosz", " ", "f", " ")
            enddo
         enddo
      endif         


      if(tkrfspec) then
         do i = 1, hnsites
            do j= 1, 3
               call kwhisti2( rfspec(j, i),
     *                0.01,  0.2, 20,  b'00011', 
     *               -1.0,  1.0, 50,   b'10000')
               call kwhiststep2(rfspec(j, i), 2)
               call kwhistai2( rfspec(j, i),
     *         "f spectrum of "//ptcl(j)//" with diff. r",
     *         "rf", "ptcls", .true., 0.,
     *          "r", "m.u", "f", " ")
            enddo
         enddo
      endif         


      if(tkefspec) then
         do i = 1, hnsites
            do j = 1, 3
               call kwhisti2( efspec(j, i),
     *              500.e-6,  0.2, 20,  b'00001', 
     *              -1.0,     1.0, 50,  b'10000')
               call kwhiststep2(efspec(j, i), 2)
               call kwhistai2( efspec(j, i),
     *         "f spectrum of "//ptcl(j)//" with diff. E",
     *         "ef", "ptcls",.true., 0.,
     *         "E", "GeV", "f", " ")
            enddo
         enddo
      endif         

      if(tkrtspec) then
         do i = 1, hnsites
            do j = 1, 3
               call kwhisti2( rtspec1(j, i),
     *              1.0, 0.2,  10,   b'00011', 
     *              10.,  0.1, 55, b'00011'  )
               call kwhiststep2(rtspec1(j, i), 2)
               call kwhistai2( rtspec1(j, i),
     *         "Arrival time dist. of "//ptcl(j)//" at diff. r",
     *         "rt", "ptcls", .true., 0.,
     *         "r", "m.u", "time", "ns")

               call kwhisti2( rtspec2(j, i),
     *             0.,  1.0, 10,  b'10000', 
     *             0., 0.25, 300, b'00000' )
               call kwhiststep2(rtspec2(j, i), 2)
               call kwhistai2( rtspec2(j, i),
     *         "Arrival time dist. of "//ptcl(j)//" at diff. r",
     *         "rt", "ptcls", .true., 0.,
     *         "r", "m.u", "time", "ns")
            enddo
         enddo
      endif

      if(tkretspec)  then
         do i = 1, hnsites
            do j = 1, 2
c                  g,e
               call kwhisti3(retspec1(j, i), 
     *          1.0,     0.2,  10,    b'00011',
     *          500.e-6, 0.25, 15,    b'01001',
     *          10.0, 0.1,  55,      b'00011' )
               call kwhiststep3(retspec1(j, i), 2, 2)
               call kwhistai3(retspec1(j, i), 
     *         "Arrival time dist. of "//ptcl(j)//" with diff. r&E",
     *         "ret", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "Time", "ns")

               call kwhisti3(retspec2(j, i), 
     *          0.0,  1.0,     10,   b'10000',
     *          500.e-6, 0.25, 12,  b'01001',
     *          0.0,  0.25,   200,  b'00000' )
               call kwhiststep3(retspec2(j, i), 2,2)
               call kwhistai3(retspec2(j, i), 
     *         "Arrival time dist. of "//ptcl(j)//" with diff. r&E",
     *         "ret2", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "Time", "ns")
            enddo
c               mu
            call kwhisti3(retspec1(3, i), 
     *           1.0,   0.2,    10,       b'00011',
     *           100.e-3, 0.25, 10,       b'01011',
     *           10.0,    0.1,  72,       b'00011' )
            call kwhiststep3(retspec1(3, i),  2, 2)
            call kwhistai3(retspec1(3, i), 
     *         "Arrival time dist. of "//ptcl(3)//" with diff. r&E",
     *         "ret", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "Time", "ns")


            call kwhisti3(retspec2(3, i), 
     *           0.0,  1.0,  10,    b'10000',
     *           100.e-3,    0.25, 10,   b'01011',
     *           0.0,  0.25,    200,     b'00000' )
            call kwhiststep3(retspec2(3, i), 2,2)
            call kwhistai3(retspec2(3, i), 
     *         "Arrival time dist. of "//ptcl(3)//" with diff. r&E",
     *         "ret2", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "Time", "ns")
         enddo
      endif


      if(tkrezspec) then
         do i = 1, hnsites
            do j = 1, 2
               call kwhisti3( rezspec(j, i), 
     *         0.1,   0.2,  15,     b'00011',
     *         500.e-6, 0.25, 14,   b'01001', 
     *         0.0, 1.0,   20,    b'10000')
               call kwhiststep3(rezspec(j, i), 3,2)
               call kwhistai3(rezspec(j, i), 
     *         "cos zenith dist. of "//ptcl(j)//" with diff. r&E",
     *         "rez", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "cosz", " ") 
            enddo
            call kwhisti3(rezspec(3, i), 
     *         0.1,  0.2,   15,   b'00011',
     *         100.e-3, 0.25, 10, b'01011', 
     *         0.0, 1.0,     20,   b'10000')
            call kwhiststep3(rezspec(3, i), 3,2)
            call kwhistai3(rezspec(3, i), 
     *         "cos zenith dist. of "//ptcl(3)//" with diff. r&E",
     *         "rez", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "cosz", " ") 
         enddo
      endif



      if(tkrzfspec) then
         do i = 1, hnsites
            do j = 1, 3
               call kwhisti3(rzfspec(j, i), 
     *         0.1, 0.2,        15,   b'00011',
     *         0.0, 1.0,        10,   b'10000',  
     *         -1.0, 1.0,       20,   b'10000')
               call kwhiststep3(rzfspec(j, i), 3,2)
               call kwhistai3(rzfspec(j, i), 
     *         "f spectrum of "//ptcl(j)//" with diff r&cosz",
     *         "rzf", "ptcls", .true., 0.,
     *         "r", "m.u", "cosz", " ", "f", " ")
            enddo
         enddo
      endif

      if(tkrefspec) then
         do i = 1, hnsites
            do j = 1, 2
               call kwhisti3( refspec(j, i), 
     *         0.1,  0.2,      15,   b'00011',
     *         500.e-6, 0.25,  16,    b'01001',  
     *         -1.0, 1.0,     20,   b'10000')
               call kwhiststep3(refspec(j, i), 3,3)
               call kwhistai3(refspec(j, i),
     *         "f spectrum of "//ptcl(j)//" with diff. r&E",
     *         "ref", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "f", " ")
            enddo
            call kwhisti3(refspec(3, i), 
     *       0.1, 0.2,      15,    b'00011',
     *       100.e-3,  0.25, 10,    b'01001',  
     *        -1.0, 1.0,     20,   b'10000')
            call kwhiststep3(refspec(3, i), 3,2)
            call kwhistai3(refspec(3, i),
     *         "f spectrum of "//ptcl(3)//" with diff. r&E",
     *         "ref", "ptcls", .true., 0.,
     *         "r", "m.u", "E", "GeV", "f", " ")
         enddo
      endif
